#include "qcolorwidget.h"
#include <QPainter>
#include <QColorDialog>

QColorWidget::QColorWidget(QWidget *parent) :
    QWidget(parent)
{
	propColor = Qt::black;
}

void QColorWidget::mousePressEvent(QMouseEvent *){
	QColorDialog corNova;
	propColor = corNova.getColor();
	emit colorChanged(propColor);
	update();
}

void QColorWidget::paintEvent(QPaintEvent *){
	QPainter pintor(this);
	pintor.setPen(QPen(QColor(0.0, 0.0, 0.0)));
	pintor.setBrush(QBrush(propColor));
	pintor.drawRect(0, 0, width()-1, height()-1);
}

QColor QColorWidget::color() const{
	return propColor;
}
