#ifndef BEZIER_H
#define BEZIER_H

#include "curva.h"

class Bezier: public Curva
{
public:
    Bezier(std::string nome, std::vector<Coordenada> pontos, Cor cor = Cor(0,0,0));
    virtual std::string tipo() const;
    virtual Objeto* clonar() const;

	virtual void persist(TiXmlNode *) const;
	virtual void restore(TiXmlElement *);
protected:
	void saveCoordenadasIdentificadas(TiXmlElement *me, iterator i, iterator end) const;
private:
	virtual std::vector<Polinomio> obterPolinomios();
};


#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDeBezier();
#endif // BEZIER_H
