#include "bezier3d.h"

Bezier3D::Bezier3D(std::string nome, std::vector<Geometria> geometrias, Cor cor): Curva3D(nome, geometrias, cor)
{
}

std::string Bezier3D::tipo() const {
        return "Bezier3D";
}

Objeto* Bezier3D::clonar() const {
    return new Bezier3D(this->nome(), this->geometrias, this->cor() );
}

std::vector<Matriz<4,4> > Bezier3D::aplicarMatriz(Geometria geometria) const {
        std::vector<Matriz<4,4> > parametros;
        Matriz<4,4> base;
        base[0][0] = -1;	base[0][1] = +3;	base[0][2] = -3;	base[0][3] = +1;
        base[1][0] = +3;	base[1][1] = -6;	base[1][2] = +3;	base[1][3] =  0;
        base[2][0] = -3;	base[2][1] = +3;	base[2][2] =  0;	base[2][3] =  0;
        base[3][0] = +1;	base[3][1] =  0;	base[3][2] =  0;	base[3][3] =  0;

        Matriz<4,4> x, y, z;

        for(int i = 0; i < 4; i++){
            for(int j = 0; j < 4; j++){
                x[i][j] = geometria[i][j].x();
                y[i][j] = geometria[i][j].y();
                z[i][j] = geometria[i][j].z();
            }
        }

        parametros.push_back(base * x * base);
        parametros.push_back(base * y * base);
        parametros.push_back(base * z * base);
        return parametros;
}
