#include "bspline.h"

BSpline::BSpline(std::string nome, std::vector<Coordenada> pontos, Cor cor  ): Curva(nome, pontos, cor)
{
}

std::vector<Curva::Polinomio> BSpline::obterPolinomios(){
        std::vector<Curva::Polinomio> retorno;
        //TODO Usar iterador
        Matriz<4,4> base;
        base[0][0] = -1/6.0;	base[0][1] = +3/6.0;	base[0][2] = -3/6.0;	base[0][3] = +1/6.0;
        base[1][0] = +3/6.0;	base[1][1] = -6/6.0;	base[1][2] = +3/6.0;	base[1][3] =  0;
        base[2][0] = -3/6.0;	base[2][1] = 0;         base[2][2] =  3/6.0;	base[2][3] =  0;
        base[3][0] = +1/6.0;	base[3][1] =  4/6.0;	base[3][2] =  1/6.0;	base[3][3] =  0;

        for(unsigned i = 0; i+3 < _coordenadas.size(); i += 1){
                Curva::Polinomio nova;
                Matriz<4,3> pontos;
                pontos[0][0] = _coordenadas[ i ].x();	pontos[0][1] = _coordenadas[ i ].y();   pontos[0][2] = _coordenadas[ i ].z();
                pontos[1][0] = _coordenadas[i+1].x();	pontos[1][1] = _coordenadas[i+1].y();   pontos[1][2] = _coordenadas[i+1].z();
                pontos[2][0] = _coordenadas[i+2].x();	pontos[2][1] = _coordenadas[i+2].y();   pontos[2][2] = _coordenadas[i+2].z();
                pontos[3][0] = _coordenadas[i+3].x();	pontos[3][1] = _coordenadas[i+3].y();   pontos[3][2] = _coordenadas[i+3].z();

                nova = base*pontos;

                retorno.push_back(nova);
        }
        return retorno;
}

std::string BSpline::tipo() const {
	return "curvaBSpline";
}

Objeto* BSpline::clonar() const {
    return new BSpline(this->nome(), _coordenadas, this->cor());
}

class FabricaDeBSpline : public FabricaDeObjeto {
public:
	~FabricaDeBSpline(){
	};
	std::string label() const{
			return "B-Spline";
	}

	char quantidadeValidaDePontos(int quantidade) const{
			return ( quantidade >= 4) ? 0 : -1;
	}
	Objeto* criar() const{
		std::string nome = ((String*)_opcoes.at(0))->value;
		std::vector<Coordenada> coordenadas = ((Coordenadas*)_opcoes.at(1))->value;
		Cor cor = ((Color*)_opcoes.at(2))->value;
		return new BSpline(nome, coordenadas, cor);
	}
	virtual Objeto* restore(TiXmlElement * who) const {
		Objeto* objeto = new BSpline("", std::vector<Coordenada>());
		objeto->restore(who);

		return objeto;
	}
};
FabricaDeBSpline unicaFabricaDeBSpline;

FabricaDeObjeto* obterFabricaDeBSpline(){
	return &unicaFabricaDeBSpline;
}

BEGIN_FACTORY_REGISTER(bspline)
	FabricaDeObjeto::fabricas["curvaBSpline"] = obterFabricaDeBSpline();
END_FACTORY_REGISTER(bspline)
