#include "bspline3d.h"

BSpline3D::BSpline3D(std::string nome, std::vector<Geometria> geometria, Cor cor): Curva3D(nome, geometria, cor)
{
}

std::string BSpline3D::tipo() const{
    return "BSpline3D";
}

Objeto* BSpline3D::clonar() const {
    return new BSpline3D(this->nome(), this->geometrias, this->cor() );
}


std::vector<Matriz<4,4> > BSpline3D::aplicarMatriz(Geometria geometria) const {
        std::vector<Matriz<4,4> > parametros;
        Matriz<4,4> base, transposta;

        base[0][0] = -1/6.0;	base[0][1] = +3/6.0;	base[0][2] = -3/6.0;	base[0][3] = +1/6.0;
        base[1][0] = +3/6.0;	base[1][1] = -6/6.0;	base[1][2] = +3/6.0;	base[1][3] =  0;
        base[2][0] = -3/6.0;	base[2][1] = 0;         base[2][2] =  3/6.0;	base[2][3] =  0;
        base[3][0] = +1/6.0;	base[3][1] =  4/6.0;	base[3][2] =  1/6.0;	base[3][3] =  0;

        transposta[0][0] = -1/6.0;	transposta[0][1] = +3/6.0;	transposta[0][2] = -3/6.0;	transposta[0][3] = +1/6.0;
        transposta[1][0] = +3/6.0;	transposta[1][1] = -6/6.0;	transposta[1][2] =		0;	transposta[1][3] =  4/6.0;
        transposta[2][0] = -3/6.0;	transposta[2][1] = +3/6.0;  transposta[2][2] =  3/6.0;	transposta[2][3] =  1/6.0;
        transposta[3][0] = +1/6.0;	transposta[3][1] =		0;	transposta[3][2] =		0;	transposta[3][3] =  0;
		
        Matriz<4,4> x, y, z;

        for(int i = 0; i < 4; i++){
            for(int j = 0; j < 4; j++){
                x[i][j] = geometria[i][j].x();
                y[i][j] = geometria[i][j].y();
                z[i][j] = geometria[i][j].z();
            }
        }

		parametros.push_back(base * x * transposta);
		parametros.push_back(base * y * transposta);
		parametros.push_back(base * z * transposta);
        return parametros;
}
