#include "estrategianear.h"

EstrategiaNear::~EstrategiaNear()
{
}

std::vector<Coordenada> EstrategiaNear::clipar(const std::vector<Coordenada>& coordenadas, Window* clipador) const{
	using std::vector;
	vector<Coordenada> retorno;
	vector<Coordenada>::const_iterator i = coordenadas.begin();

        double near = clipador->near();
	bool dentro;
        if(i == coordenadas.end())
                 return retorno;
	if( i->z() >= near){
		dentro=true;
		retorno.push_back(*i);
	}else{
		dentro=false;
	}

	for(i++; i != coordenadas.end(); i++){
		if( i->isNull() ){
			retorno.push_back( *i );
			i++;
			if(i == coordenadas.end())
				break;
			if( i->z() >= near){
				dentro=true;
				retorno.push_back(*i);
			}else{
				dentro=false;
			}
			continue;
		}
		if( i->z() >= near){
			if(dentro){
				retorno.push_back(*i);
			}else{
				dentro = true;
				retorno.push_back( clipar( *(i-1), *i,  clipador));
				retorno.push_back( *i );
			}
		}else{
			if(dentro){
				dentro = false;
				retorno.push_back( clipar( *i, *(i-1), clipador));
			}
		}
	}

	return retorno;

}

Coordenada EstrategiaNear::clipar(Coordenada origem, Coordenada fim, Window * clipador) const{
	Coordenada retorno;
        double near = clipador->near();
	double u = (origem.z() - near) / (origem.z() - fim.z());

	retorno.x(origem.x() + u*(fim.x() - origem.x()));
	retorno.y(origem.y() + u*(fim.y() - origem.y()));
	retorno.z(near);
	return retorno;
}
