#include "clipping/estrategiapoligonoviaretas.h"
#include "clipping/estrategiasutherland.h"

std::vector<Coordenada> EstrategiaPoligonoViaRetas::clipar(const std::vector<Coordenada>& coordenadas, Window* clipador) const{
	if( coordenadas.size() == 0)
		return coordenadas;

	using std::vector;
	vector<Coordenada> retorno;
	vector<Coordenada>::const_iterator i = coordenadas.begin();

	EstrategiaSutherland estrategia;

	bool dentro;

	if( estrategia.obterRegiao(*i, clipador) == 0){
		dentro=true;
		retorno.push_back(*i);
	}else{
		dentro=false;
	}

	for(i++; i != coordenadas.end(); i++){
		if( i->isNull() ){
			retorno.push_back(*i);
			i++;
			if(i == coordenadas.end())
				break;
			if( estrategia.obterRegiao(*i, clipador) == 0){
				dentro=true;
				retorno.push_back(*i);
			}else{
				dentro=false;
			}
			continue;
		}
		vector<Coordenada> clipadas = estrategia.clipar(*(i-1), *i, clipador);
		if( estrategia.obterRegiao(*i, clipador) == 0){
			if( !dentro )
				retorno.push_back(clipadas[0]);
			retorno.push_back(*i);
			dentro = true;
		}else{
			if(clipadas.size() > 0){
				retorno.push_back(clipadas[0]);
				retorno.push_back(clipadas[1]);
				retorno.push_back(Coordenada());
			}
			dentro = false;
		}
	}

	return retorno;

};
