#ifndef ESTRATEGIASUTHERLAND_H
#define ESTRATEGIASUTHERLAND_H

#define TOP 0x1
#define BOTTOM 0x2
#define RIGHT 0x4
#define LEFT 0x8

#include "clipping/estrategiareta.h"

class EstrategiaSutherland : public EstrategiaReta
{
public:
	virtual std::vector<Coordenada> clipar(const Coordenada&, const Coordenada&, Window*) const;

public:
	char obterRegiao(const Coordenada&, Window*) const;
	bool puxar(Coordenada& puxada, const Coordenada& inicio, const Coordenada& fim, char regiao, Window*) const;

public:
	double xEm(double y, const Coordenada& origem, const Coordenada& fim) const;
	double yEm(double x, const Coordenada& origem, const Coordenada& fim) const;
	double a(const Coordenada& origem, const Coordenada& fim) const;
	double b(const Coordenada& origem, const Coordenada& fim) const;
};

#endif // ESTRATEGIASUTHERLAND_H
