#ifndef __COORDENADA_H
#define __COORDENADA_H

#define COORDENADA_LARGURA 4
#define DIM COORDENADA_LARGURA

#include "matriz.h"
#include "tinyxml/tinyxml.h"

class Coordenada: public Matriz<1,COORDENADA_LARGURA>{
public:
	Coordenada(double x, double y, double z=0.0);
	Coordenada(const Matriz<1,COORDENADA_LARGURA>&);
	Coordenada(const Coordenada& coordenada);
	Coordenada();
	virtual	~Coordenada();

	void persist(TiXmlElement*) const;
	void restore(TiXmlElement*);


	bool isNull() const;

	double x() const;
	void x(double novoX);
	double y() const;
	void y(double novoY);
	double z() const;
	void z(double novoZ);

	Coordenada operator+(const Coordenada&) const;
	Coordenada operator-(const Coordenada&) const;
	Coordenada operator*(double) const;

	bool operator==(const Coordenada&) const;
};
#endif
