#include "cor.h"
#include <sstream>
#include <string>

Cor::Cor(int red, int green, int blue): _red(red), _green(green), _blue(blue) {
}

Cor::~Cor() {
}

Cor::Cor(const QColor& qcolor) {
       _red = qcolor.red();
       _green = qcolor.green();
       _blue = qcolor.blue();
}

Cor::Cor(const std::string& hex) {
	typedef std::stringstream convert;
	using std::string;

	convert r,g,b;

	r << hex[0];
	r << hex[1];
	g << hex[2];
	g << hex[3];
	b << hex[4];
	b << hex[5];

	r >> std::hex >> _red;
	g >> std::hex >> _green;
	b >> std::hex >> _blue;

};

QColor Cor::qcolor(){
	return QColor(_red, _green, _blue);
}

int Cor::red() const{
    return _red;
}

int Cor::green() const{
    return _green;
}

int Cor::blue() const{
    return _blue;
}

void Cor::red(const int& novoRed){
    _red = novoRed;
}

void Cor::green(const int& novoGreen){
    _green = novoGreen;
}

void Cor::blue(const int& novoBlue){
    _blue = novoBlue;
}

bool Cor::operator==(const Cor& that) const{
	return this->red() == that.red() && this->green() == that.green() && this->blue() == that.blue();
}

std::string Cor::hex() const {
	typedef std::stringstream convert;
	using std::string;
	convert _r;
	convert _g;
	convert _b;

	string r;
	string g;
	string b;

	_r << std::hex << _red;
	_g << std::hex << _green;
	_b << std::hex << _blue;

	r = _r.str();
	g = _g.str();
	b = _b.str();

	if( r.size() == 1 )
		r = "0" + r;
	if( g.size() == 1 )
		g = "0" + g;
	if( b.size() == 1 )
		b = "0" + b;

	return r + g + b;
};
