#include "curva.h"
#include "window.h"
#include "clipping/estrategiapoligonoviaretas.h"
#include "clipping/estrategianear.h"

Curva::Curva(std::string nome, std::vector<Coordenada> pontos, Cor cor): ObjetoClipavel(nome, cor)
{
    _coordenadas = pontos;
    _nivelDePreenchimento = 1;
//    extrairPolinomios();
}

Curva::~Curva(){
}

#include "poligono.h"
#include <iostream>
#define min(a,b) ( (a) < (b) ? (a) : (b) )
void Curva::recalcularCache(Window* clipador){
    std::vector<Coordenada> retas;
	double step = min(clipador->viewUpVector().modulo()/500.0, 1/5.0);
//	double step = 1.0/3.0;

	std::vector<Polinomio> polinomios = obterPolinomios();

	for(std::vector<Polinomio>::iterator i=polinomios.begin(); i != polinomios.end(); ++i){

//		Isso aqui vai ficar comentado por enquanto pra que a gente tenha o código que use
//		polinômios em algum lugar.
//		for(double t=0.0-step; t < 1.0; ){
//			t = min(t+step, 1.0);
//
//			Matriz<1,4> ts;
//			ts[0][3] = 1;
//			ts[0][2] = t;
//			ts[0][1] = t*ts[0][2];
//			ts[0][0] = t*ts[0][1];
//
//			Matriz<1,2> ponto = ts*(*i);
//			retas.push_back(Coordenada(ponto[0][0], ponto[0][1]));
//		};

                Matriz<4,3> diferencasDividas;
                for(int coluna=0;coluna<3;coluna++){
			double a = (*i)[0][coluna], b = (*i)[1][coluna], c = (*i)[2][coluna], d = (*i)[3][coluna];
			diferencasDividas[0][coluna] = d;
			diferencasDividas[1][coluna] = a*pow(step, 3) + b*pow(step, 2) + c*step;
			diferencasDividas[2][coluna] = 6*a*pow(step,3) + 2*b*pow(step, 2);
			diferencasDividas[3][coluna] = 6*a*pow(step,3);
		}
                retas.push_back(Coordenada(diferencasDividas[0][0], diferencasDividas[0][1], diferencasDividas[0][2]));

		for(double t=step; t < 1.0; t+=step){
                        for(int coluna=0; coluna   < 3; ++coluna)
			for(int linha=0; linha+1 < 4; ++linha){
				diferencasDividas[linha][coluna] += diferencasDividas[linha+1][coluna];
			}
                        retas.push_back(Coordenada(diferencasDividas[0][0], diferencasDividas[0][1], diferencasDividas[0][2]));
                };{	double t= 1.0;
			Matriz<1,4> um;
			um[0][0] = 1.0;
			um[0][1] = t;
			um[0][2] = t*t;
			um[0][3] = t*t*t;
                        Matriz<1,3> ultimoPonto = um*(*i);
                        retas.push_back(Coordenada(ultimoPonto[0][0], ultimoPonto[0][1], ultimoPonto[0][2]));
		}
	}


        _coordenadasClipadas = EstrategiaPoligonoViaRetas().clipar(aplicarPerspectiva(EstrategiaNear().clipar(retas, clipador), clipador), clipador);
}


std::string Curva::tipo() const{
    return "Curva";
}
