#ifndef CURVA3D_H
#define CURVA3D_H
#include "objetoclipavel.h"

class Curva3D: public ObjetoClipavel
{
public:
	typedef Coordenada** Geometria;
    Curva3D(std::string nome, std::vector<Geometria> geometrias, Cor cor = Cor(0.0,0.0,0.0) );
    virtual ~Curva3D();
    virtual std::string tipo() const;

	virtual void aplicarTransformacao(const Transformacao &);
    virtual void recalcularCache(Window* clipador);
    virtual Objeto* clonar() const =0 ;
protected:
    std::vector<Geometria> geometrias;
private:
    virtual std::vector<Matriz<4,4> > aplicarMatriz(Geometria) const =0;
};

#endif // CURVA3D_H
