#include "displayfile.h"
#include "reta.h"
#include "poligono.h"
#include "ponto.h"
#include "fabricadeobjeto.h"

DisplayFile::DisplayFile()
{
}

DisplayFile::~DisplayFile()
{
	//TODO Delete pointers.
}

void DisplayFile::persist(TiXmlNode * where) const {
	for(const_iterator i = begin(); i != end(); ++i) {
		(*i)->persist(where);
	}
}
#include <iostream>
void DisplayFile::restore(TiXmlNode * where) {
    TiXmlNode* child = 0;
	clear();//TODO And delete
	while( (child = where->IterateChildren(child)) ) {
        TiXmlElement *each = child->ToElement();
		FabricaDeObjeto::iterator fabrica = FabricaDeObjeto::fabricas.find(each->Value());
		if(fabrica == FabricaDeObjeto::fabricas.end())
			continue;

		Objeto* newObject = (fabrica->second)->restore(each);
		push_back(newObject);
    }
}

Coordenada DisplayFile::menorPonto() const{
	double menorX=0.0;
	double menorY=0.0;
	for(const_iterator i=begin();i!=end();i++){
		for(Objeto::iterator j = (*i)->coordenadasBegin(); j != (*i)->coordenadasEnd(); j++){
			if(j->x() < menorX)
				menorX = j->x();
			if(j->y() < menorY)
				menorY = j->y();
		}
	}
	return Coordenada(menorX, menorY);
}

Coordenada DisplayFile::maiorPonto() const{
	double maiorX=0.0;
	double maiorY=0.0;
	for(const_iterator i=begin();i!=end();i++){
		for(Objeto::iterator j = (*i)->coordenadasBegin(); j != (*i)->coordenadasEnd(); j++){
			if(j->x() > maiorX)
				maiorX = j->x();
			if(j->y() > maiorY)
				maiorY = j->y();
		}
	}
	return Coordenada(maiorX, maiorY);
}

DisplayFile DisplayFile::clonarObjetos() const{
	DisplayFile retorno;
	for(const_iterator i=begin(); i!=end(); i++){
		retorno.push_back( (*i)->clonar() );
	}
	return retorno;
}

void DisplayFile::aplicarTransformacao(const Transformacao& transformacao){
	for(iterator i=begin(); i != end(); i++){
		Objeto* atual = *i;
		atual->aplicarTransformacao(transformacao);
	}
}
