#include "matriz.h"

MatrizNuclear::MatrizNuclear(int linhas, int colunas){
	this->linhas = linhas;
	this->colunas = colunas;
	valores = new double[linhas*colunas];
	for(int i=0;i<linhas*colunas;i++)
		valores[i] = 0.0;
}
MatrizNuclear::MatrizNuclear(const MatrizNuclear& outra){
	this->linhas = outra.linhas;
	this->colunas = outra.colunas;
	valores = new double[linhas*colunas];
	for(int i=0;i<linhas*colunas;i++){
		this->valores[i] = outra.valores[i];
	}
}

MatrizNuclear::~MatrizNuclear(){
	//		TODO
			delete valores;
}

void MatrizNuclear::operator=(const MatrizNuclear& outra){
	this->linhas = outra.linhas;
	this->colunas = outra.colunas;
	valores = new double[linhas*colunas];
	for(int i=0;i<linhas*colunas;i++){
		this->valores[i] = outra.valores[i];
	}
}

MatrizNuclear& MatrizNuclear::operator*=(const MatrizNuclear& outra){
	if(this->colunas != outra.linhas || outra.linhas != outra.colunas){
		throw "A segunda matriz não tem a ordem esperada ou não é quadrada.";
	}
	MatrizNuclear temporaria = (*this)*outra;
	for(int i=0;i<linhas*colunas;i++)
		valores[i] = temporaria.valores[i];
	return *this;
}
MatrizNuclear MatrizNuclear::operator*(const MatrizNuclear& outra) const{
	if(this->colunas != outra.linhas){
		throw "A segunda matriz não tem as dimensões esperadas.";
	}
	MatrizNuclear resultado(linhas, outra.colunas);
	for(int cadaLinha = 0; cadaLinha < linhas; cadaLinha++){
	for(int cadaColuna = 0; cadaColuna < outra.colunas; cadaColuna++)
	for(int cadaElemento = 0; cadaElemento < colunas; cadaElemento++)
		resultado[cadaLinha][cadaColuna] += (*this)[cadaLinha][cadaElemento]*outra[cadaElemento][cadaColuna];
	}
	return resultado;
}
double* MatrizNuclear::operator[](int elemento) const{
	return &(valores[elemento*colunas]);
}

bool MatrizNuclear::operator==(const MatrizNuclear& outra) const{
	for(int i = 0; i < linhas*colunas; i++)
	if( valores[i] != outra.valores[i] )
		return false;
	return true;
}

bool MatrizNuclear::operator!=(const MatrizNuclear& outra) const{
	return ! ((*this) == outra);
}
