#ifndef MATRIZ_H
#define MATRIZ_H

#include <cmath>

class MatrizNuclear {
public:
	MatrizNuclear(int linhas, int colunas);
	MatrizNuclear(const MatrizNuclear& outra);
	virtual ~MatrizNuclear();
	void operator=(const MatrizNuclear& outra);
	MatrizNuclear& operator*=(const MatrizNuclear& outra);
	MatrizNuclear operator*(const MatrizNuclear& outra) const;
	double* operator[](int elemento) const;

	bool operator==(const MatrizNuclear& outra) const;

	bool operator!=(const MatrizNuclear& outra) const;
public:
	static MatrizNuclear rotacao(double anguloRoll = 0, double anguloPitch = 0, double anguloYaw = 0, MatrizNuclear centro = MatrizNuclear(1,4));
private:
	double* valores;
	int linhas, colunas;
};


template <int LINHAS, int COLUNAS=LINHAS>
class Matriz
{
public:
    Matriz() : nucleo(LINHAS, COLUNAS){}

    Matriz(const Matriz<LINHAS,COLUNAS>& outra) : nucleo(outra.nucleo){}

    Matriz<LINHAS,COLUNAS>& operator*=(Matriz<COLUNAS, COLUNAS> outra){
	    nucleo *= outra.nucleo;
	    return *this;
    };

    virtual ~Matriz(){
    };

    double* operator[](int elemento){
	return nucleo[elemento];
    }

	Matriz<LINHAS, COLUNAS>& operator=(const Matriz<LINHAS, COLUNAS>& that){
		this->nucleo = that.nucleo;
		return *this;
	}

    const double* operator[](int elemento) const{
	return nucleo[elemento];
    }

    bool operator==(const Matriz<LINHAS, COLUNAS>& outra) const{
	return nucleo == outra.nucleo;
    }

    bool operator!=(const Matriz<LINHAS, COLUNAS>& outra) const{
	return nucleo != outra.nucleo;
    }

    template <int X>
    Matriz<LINHAS, X> operator*(Matriz<COLUNAS, X> outra) const{
		Matriz<LINHAS, X> resultado;
		resultado.nucleo = nucleo*outra.nucleo;
		return resultado;
    };

public:
	MatrizNuclear nucleo;
};

typedef Matriz<1,3> MatrizLinha;


#endif // MATRIZ_H
