#ifndef OBJETO3D_H
#define OBJETO3D_H

#include "objetoclipavel.h"

class Objeto3D: public ObjetoClipavel
{
public:
	typedef std::pair<Coordenada, Coordenada> Aresta;
	typedef std::vector<Aresta> Arestas;

    Objeto3D(std::string nome, Cor cor, std::vector<Coordenada> vertices, Arestas arestas, bool wireframe);
    virtual ~Objeto3D();

	virtual void persist(TiXmlNode *) const;
	virtual void restore(TiXmlElement *);

    virtual void recalcularCache(Window* clipador);
    virtual std::string tipo() const;
    virtual Objeto* clonar() const;
    virtual void aplicarTransformacao(const Transformacao &);
private:
    Arestas arestas;
};

#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDeObjeto3D();


#endif // OBJETO3D_H
