#include "objetoclipavel.h"
#include "window.h"

void ObjetoClipavel::aplicarTransformacao(const Transformacao& transformacao){
	Objeto::aplicarTransformacao(transformacao);
	validadorDeCache[0] = Coordenada();
	validadorDeCache[1] = Coordenada();
	validadorDeCache[2] = Coordenada();
}

ObjetoClipavel::iterator ObjetoClipavel::coordenadasBegin(Window* clipador){
	tentarAtualizarCache(clipador);

	return _coordenadasClipadas.begin();
}

int ObjetoClipavel::coordenadasSize(Window* clipador){
	tentarAtualizarCache(clipador);

	return _coordenadasClipadas.size();
}

ObjetoClipavel::iterator ObjetoClipavel::coordenadasEnd(Window*) const{
	return _coordenadasClipadas.end();
}

bool ObjetoClipavel::seDeveAtualizarCache(Window* clipador) const{
	int j = 0;
	for(Window::iterator i = clipador->coordenadasBegin(); i != clipador->coordenadasEnd() && j < 3; ++i){
		if((*i) != validadorDeCache[j]){
			return true;
		}
		++j;
	}
	return false;
}

void ObjetoClipavel::tentarAtualizarCache(Window* clipador){
	if(seDeveAtualizarCache(clipador)){
		recalcularCache(clipador);
		int j = 0;
		for(Window::iterator i = clipador->coordenadasBegin(); i != clipador->coordenadasEnd() && j < 3; ++i){
			validadorDeCache[j] = *i;
			++j;
		}
	}
}
