#ifndef OBJETOCLIPAVEL_H
#define OBJETOCLIPAVEL_H

#include "objeto.h"

class ObjetoClipavel : public Objeto
{
public:
        ObjetoClipavel(std::string nome, Cor cor) : Objeto(nome, cor)
        {}
        virtual ~ObjetoClipavel(){}

	virtual void aplicarTransformacao(const Transformacao&);

	// C++ Com Erro Bizarro.
	virtual iterator coordenadasBegin() const {
		return Objeto::coordenadasBegin();
	}
	virtual iterator coordenadasEnd() const {
		return Objeto::coordenadasEnd();
	}
	virtual int coordenadasSize() const {
		return Objeto::coordenadasSize();
	}

	virtual iterator coordenadasBegin(Window* clipador);
	virtual int coordenadasSize(Window* clipador);
	virtual iterator coordenadasEnd(Window* clipador) const;

protected:
	std::vector<Coordenada> _coordenadasClipadas;
	virtual void recalcularCache(Window* clipador)=0;
	virtual bool seDeveAtualizarCache(Window* clipador) const;
private:
	void tentarAtualizarCache(Window* clipador);
	Coordenada validadorDeCache[3];
};

#endif // OBJETOCLIPAVEL_H
