#ifndef POLIGONO_H
#define POLIGONO_H

#include "objetoclipavel.h"
#include "clipping/estrategiapoligono.h"

class Poligono: public ObjetoClipavel{
public:
    Poligono(std::string, Cor cor = Cor(0,0,0));
    Poligono(std::string, std::vector<Coordenada> coordenadas, Cor cor = Cor(0,0,0), bool preenchido=false);

	virtual void persist(TiXmlNode *) const;
	virtual void restore(TiXmlElement *);

	virtual ~Poligono();
	virtual std::string tipo() const;
    virtual Coordenada centro() const;

	virtual void recalcularCache(Window* clipador);

    virtual Objeto* clonar() const;

private:
	EstrategiaPoligono* estrategia;
};

#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDePoligono();


#endif // POLIGONO_H
