#include "window.h"
#include "ponto.h"

#include <boost/algorithm/string/case_conv.hpp>

Ponto::Ponto(std::string nome, Coordenada coordenada, Cor cor): ObjetoClipavel(nome, cor){
	_coordenadas.push_back(coordenada);
	_nivelDePreenchimento = 0;
}

void Ponto::recalcularCache(Window* clipador){
	if( -clipador->viewRightVector().modulo()/2 <= _coordenadas[0].x() && _coordenadas[0].x() <= clipador->viewRightVector().modulo()/2 &&
		-clipador->viewUpVector().modulo()/2 <= _coordenadas[0].y() && _coordenadas[0].y() <= clipador->viewUpVector().modulo()/2
		)
		_coordenadasClipadas = _coordenadas;
	else
		_coordenadasClipadas = std::vector<Coordenada>();
}

Ponto::~Ponto(){
}

#include <iostream>
void Ponto::persist(TiXmlNode * where) const {
	TiXmlElement* me = createTag();
	saveNameAndColor(me);
	_coordenadas[0].persist(me);
	where->LinkEndChild(me);
}
void Ponto::restore(TiXmlElement * who) {
	Objeto::restore(who);
	Coordenada coordenada;
	coordenada.restore(who);
	_coordenadas.clear();
	_coordenadas.push_back(coordenada);
}

std::string Ponto::tipo() const{
	return "ponto";
}

Objeto* Ponto::clonar() const{
	return new Ponto(this->nome(), _coordenadas[0], this->cor());
}

class FabricaDePonto : public FabricaDeObjeto {
public:
	~FabricaDePonto(){
	};
	std::string label() const{
		return "Ponto";
	}
	char quantidadeValidaDePontos(int quantidade) const{
		return (quantidade < 1) ? -1 : 1;
	}
	Objeto* criar() const{
		std::string nome = ((String*)_opcoes.at(0))->value;
		Coordenada ponto = ((Coordenadas*)_opcoes.at(1))->value.at(0);
		Cor cor = ((Color*)_opcoes.at(2))->value;
		return new Ponto(nome, ponto, cor);
	}

	virtual Objeto* restore(TiXmlElement* who) const {
		Objeto* ponto = new Ponto("", Coordenada());
		ponto->restore(who);

		return ponto;
	}
};
FabricaDePonto unicaFabricaDePonto;

FabricaDeObjeto* obterFabricaDePonto(){
	return &unicaFabricaDePonto;
}

BEGIN_FACTORY_REGISTER(ponto)
    FabricaDeObjeto::fabricas["ponto"] = obterFabricaDePonto();
END_FACTORY_REGISTER(ponto_call)
