#include <boost/test/unit_test.hpp>
#include "cor.h"

BOOST_AUTO_TEST_SUITE( testes )
BOOST_AUTO_TEST_SUITE( cor )
BOOST_AUTO_TEST_SUITE( comoHex )

BOOST_AUTO_TEST_CASE( fromHex ) {
	Cor minha( std::string("000000") );
	BOOST_CHECK_EQUAL(minha.red(), 0);
	BOOST_CHECK_EQUAL(minha.green(), 0);
	BOOST_CHECK_EQUAL(minha.blue(), 0);

	minha = Cor( std::string("FFFFFF") );
	BOOST_CHECK_EQUAL(minha.red(), 255);
	BOOST_CHECK_EQUAL(minha.green(), 255);
	BOOST_CHECK_EQUAL(minha.blue(), 255);

	minha = Cor( std::string("FF0000") );
	BOOST_CHECK_EQUAL(minha.red(), 255);
	BOOST_CHECK_EQUAL(minha.green(), 0);
	BOOST_CHECK_EQUAL(minha.blue(), 0);

	minha = Cor( std::string("0FF000") );
	BOOST_CHECK_EQUAL(minha.red(), 15);
	BOOST_CHECK_EQUAL(minha.green(), 255-15);
	BOOST_CHECK_EQUAL(minha.blue(), 0);

	minha = Cor( std::string("00FF00") );
	BOOST_CHECK_EQUAL(minha.red(), 0);
	BOOST_CHECK_EQUAL(minha.green(), 255);
	BOOST_CHECK_EQUAL(minha.blue(), 0);

	minha = Cor( std::string("000FF0") );
	BOOST_CHECK_EQUAL(minha.red(), 0);
	BOOST_CHECK_EQUAL(minha.green(), 15);
	BOOST_CHECK_EQUAL(minha.blue(), 255-15);

	minha = Cor( std::string("0000FF") );
	BOOST_CHECK_EQUAL(minha.red(), 0);
	BOOST_CHECK_EQUAL(minha.green(), 0);
	BOOST_CHECK_EQUAL(minha.blue(), 255);
}

BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()
