#include "transformacao.h"

Transformacao Transformacao::rotacao(double anguloRoll, double anguloPitch, double anguloYaw, Matriz<1,4> centro) {
	anguloRoll = (M_PI*anguloRoll)/180.0;
	anguloPitch = (M_PI*anguloPitch)/180.0;
	anguloYaw = (M_PI*anguloYaw)/180.0;

	double x = centro[0][0], y = centro[0][1], z = centro[0][2];
	Transformacao roll, pitch, yaw, retorno;

	//TODO Verificar isso aqui.

	roll[0][0] = 1;						roll[0][1] = 0;						roll[0][2] = 0;					roll[0][3] = 0;
	roll[1][0] = 0;						roll[1][1] = cos(anguloRoll);	    roll[1][2] = sin(anguloRoll);	roll[1][3] = 0;
	roll[2][0] = 0;						roll[2][1] = -sin(anguloRoll);	    roll[2][2] = cos(anguloRoll);	roll[2][3] = 0;
	roll[3][0] = 0;						roll[3][1] = 0;						roll[3][2] = 0;					roll[3][3] = 1;

	yaw[0][0] = cos(anguloYaw);		yaw[0][1] = sin(anguloYaw);		yaw[0][2] = 0;				yaw[0][3] = 0;
	yaw[1][0] = -sin(anguloYaw);	yaw[1][1] = cos(anguloYaw);		yaw[1][2] = 0;				yaw[1][3] = 0;
	yaw[2][0] = 0;					yaw[2][1] = 0;					yaw[2][2] = 1;				yaw[2][3] = 0;
	yaw[3][0] = 0;					yaw[3][1] = 0;					yaw[3][2] = 0;				yaw[3][3] = 1;

	pitch[0][0] = cos(anguloPitch);			pitch[0][1] = 0;						pitch[0][2] = -sin(anguloPitch);	pitch[0][3] = 0;
	pitch[1][0] = 0;						pitch[1][1] = 1;						pitch[1][2] = 0;					pitch[1][3] = 0;
	pitch[2][0] = sin(anguloPitch);			pitch[2][1] = 0;						pitch[2][2] = cos(anguloPitch);		pitch[2][3] = 0;
	pitch[3][0] = 0;						pitch[3][1] = 0;						pitch[3][2] = 0;					pitch[3][3] = 1;

	if( x != 0 || y != 0 || z != 0){
		retorno = translacao(-x,-y,-z) * roll * pitch * yaw * translacao(x,y,z);
	}else{
		retorno = roll * pitch * yaw;
	}

	return retorno;
}

Transformacao::Transformacao() : Matriz<4,4>() {
	(*this)[0][0] = 1;
	(*this)[1][1] = 1;
	(*this)[2][2] = 1;
	(*this)[3][3] = 1;
}

Transformacao Transformacao::translacao(double dx, double dy, double dz) {
	Transformacao retorno;
	retorno[0][0] = 1;  retorno[0][1] = 0;  retorno[0][2] = 0;  retorno[0][3] = 0;
	retorno[1][0] = 0;  retorno[1][1] = 1;  retorno[1][2] = 0;  retorno[1][3] = 0;
	retorno[2][0] = 0;  retorno[2][1] = 0;  retorno[2][2] = 1;  retorno[2][3] = 0;
	retorno[3][0] = dx; retorno[3][1] = dy; retorno[3][2] = dz; retorno[3][3] = 1;
	return retorno;
}


Transformacao Transformacao::escala(double sx, double sy, double sz, double x, double y, double z){
	Transformacao retorno;
	retorno[0][0] = sx; retorno[0][1] = 0; retorno[0][2] = 0; retorno[0][3] = 0;
	retorno[1][0] = 0; retorno[1][1] = sy; retorno[1][2] = 0; retorno[1][3] = 0;
	retorno[2][0] = 0; retorno[2][1] = 0; retorno[2][2] = sz; retorno[2][3] = 0;
	retorno[3][0] = 0;	retorno[3][1] = 0;	retorno[3][2] = 0;	retorno[3][3] = 1;

	if( x != 0 || y != 0 || z != 0){
		retorno = translacao(-x,-y,-z) * retorno;
		retorno *= translacao(x,y,z);
	}
	return retorno;
}

void Transformacao::persist(TiXmlElement* who) const {
	char pos = 'a';
	char nome[2];
	nome[1] = '\0';
	for(int i=0; i < 4; i++)
	for(int j=0; j < 4; j++){
		nome[0] = pos;
		who->SetDoubleAttribute(nome, (*this)[i][j]);
		pos++;
	}
}
void Transformacao::restore(TiXmlElement* who) {
	char pos = 'a';
	char nome[2];
	nome[1] = '\0';
	for(int i=0; i < 4; i++)
	for(int j=0; j < 4; j++){
		double value = (*this)[i][j];
		nome[0] = pos;
		who->QueryDoubleAttribute(nome, &value);
		(*this)[i][j] = value;
		pos++;
	}
}
