#ifndef TRANSFORMACAO_H
#define TRANSFORMACAO_H

#include "tinyxml/tinyxml.h"
#include "matriz.h"

class Transformacao : public Matriz<4,4>
{
public:
	Transformacao();
	Transformacao(const Matriz<4,4>& copia) : Matriz<4,4>(copia) {};
	virtual ~Transformacao(){};
	/**
	  Recebendo angulo em graus, mas internamente usamos radianos.
	  Roll - angulo ao redor do eixo X.
	  Pitch - ao redor do eixo Y.
	  Yaw - eixo Z.
	  */
        static Transformacao rotacao(double anguloRoll = 0, double anguloPitch = 0, double anguloYaw = 0, Matriz<1,4> centro = (Matriz<1,4>()));

	static Transformacao translacao(double dx, double dy, double dz = 0.0);

	static Transformacao escala(double sx, double sy, double sz, double x=0, double y=0, double z=0);

	void persist(TiXmlElement* ) const;
	void restore(TiXmlElement*);
};

#endif // TRANSFORMACAO_H
