#ifndef VETOR_H
#define VETOR_H

#include "matriz.h"
#include "coordenada.h"
#include <iostream>
#include "transformacao.h"


class Vetor : public Coordenada
{
public:
	Vetor(double x=0.0, double y=0.0, double z=0.0);
	Vetor(const Matriz<1,COORDENADA_LARGURA>&);
	Vetor(const Coordenada& coordenada);
	virtual ~Vetor();

	double produtoEscalar(const Vetor&) const;
	double modulo() const;

	/**
	  * @return A Vetor defined as (angle in x, angle in y, angle in z)
	  */
	Vetor angulo(const Vetor&) const;

	Vetor girado90GrausEmX() const;
	Vetor girado90GrausEmY() const;
	Vetor girado90GrausEmZ() const;

	Vetor operator*(const Transformacao&) const;
	/**
	  * @return o produto um a um
	  */
	Vetor operator*(const Vetor&) const;
	Vetor operator*(double) const;
	Vetor normalized() const;
	Vetor crossProduct(const Vetor& outro) const;

};

std::ostream &operator<<(std::ostream& stream, Vetor escopo);


#endif // VETOR_H
