#ifndef WINDOW_H
#define WINDOW_H
class Window;

#include "objeto.h"
#include <vector>
#include "displayfile.h"
#include "vetor.h"

class Window: public Objeto
{
	friend class Viewport;
public:
	Window(Coordenada inferiorEsquerdo, Coordenada superiorDireito, Coordenada centroDaProjecao);
	virtual ~Window();

	void persist(TiXmlNode*) const;
	void restore(TiXmlNode*);

	Coordenada inferiorEsquerdo() const;
	void inferiorEsquerdo(const Coordenada&);

	Coordenada superiorDireito() const;
	void superiorDireito(const Coordenada&);

	Coordenada superiorEsquerdo() const;
	void superiorEsquerdo(const Coordenada&);

	void mover(double sentidoX, double sentidoY, double sentidoZ);
	void escala(double);
	void rodar(double roll, double pitch, double yaw);

	void atualizarCPP(const DisplayFile&);

	DisplayFile coordenadasDePlanoDeProjecao() const;

	Vetor viewUpVector() const;
	Vetor viewRightVector() const;
	Vetor viewPlaneNormal() const;
	Coordenada centerOfProjection() const;
	double near() const;
private:
	DisplayFile _coordenadasDePlanoDeProjecao;
	Coordenada _centerOfProjection;
	Transformacao compensacao;
};

#endif // WINDOW_H
