#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "novoobjeto.h"
#include <QTableWidgetItem>
#include <QKeyEvent>
#include <vector>

#include <QFileDialog>

#include "libcg/ponto.h"
#include "libcg/reta.h"
#include "libcg/poligono.h"
#include "libcg/bezier.h"
#include "libcg/bspline.h"
#include "libcg/objeto3d.h"
#include "libcg/bezier3d.h"
#include "libcg/bspline3d.h"

#include "libcg/transformacao.h"

#include "libcg/tinyxml/tinyxml.h"

#include <iostream>
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    this->showMaximized();
    setFocusPolicy(Qt::StrongFocus);
    ui->setupUi(this);

    Coordenada **geometrias;
    geometrias = new Coordenada*[4];
    for(int i = 0; i < 4; i++)
        geometrias[i] = new Coordenada[4];
//    Coordenada geometrias[4][4];
    std::vector<BSpline3D::Geometria> blah;
    for(int i = 0; i < 4; i++){
        for(int j = 0; j < 4; j++){
           geometrias[i][j] = Coordenada(10*j, 0.0, 10*i);
        }
    }
	blah.push_back(geometrias);
    BSpline3D* bezierzinha = new BSpline3D("bezier3D?", blah);
//	ui->canvas->displayFile()->push_back(bezierzinha);

        std::vector<Coordenada> pontos;
		pontos.push_back(Coordenada(-10.0, -10.0, 11.0));
		pontos.push_back(Coordenada(10.0, -10.0, 11.0));
		pontos.push_back(Coordenada(10.0, 10.0, 11.0));
		pontos.push_back(Coordenada(-10.0, 10.0, 11.0));
		pontos.push_back(Coordenada(-10.0, -10.0, 31.0));
		pontos.push_back(Coordenada(10.0, -10.0, 31.0));
		pontos.push_back(Coordenada(10.0, 10.0, 31.0));
		pontos.push_back(Coordenada(-10.0, 10.0, 31.0));

		std::vector<std::pair<Coordenada, Coordenada> > arestas;
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[0], pontos[1]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[0], pontos[3]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[0], pontos[4]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[1], pontos[2]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[1], pontos[5]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[2], pontos[3]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[2], pontos[6]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[3], pontos[7]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[4], pontos[5]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[5], pontos[6]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[6], pontos[7]));
		arestas.push_back(std::pair<Coordenada,Coordenada>(pontos[7], pontos[4]));
		Objeto3D* objetinho = new Objeto3D("Objetinho", Cor(0.0,0.0,0.0), pontos, arestas, true);
//		ui->canvas->displayFile()->push_back(objetinho);
        pontos.clear();
        pontos.push_back(Coordenada(0.0,0.0,20.0));
        pontos.push_back(Coordenada(5.0,0.0,20.0));
        pontos.push_back(Coordenada(5.0,5.0,20.0));
		pontos.push_back(Coordenada(10.0,10.0,20.0));
		pontos.push_back(Coordenada(15.0,10.0,20.0));
		pontos.push_back(Coordenada(15.0,15.0,20.0));
		pontos.push_back(Coordenada(20.0,20.0,20.0));
//		Objeto* poligoninho = new Bezier("poligono", pontos, Cor(255.0,0.0,0.0));
//		ui->canvas->displayFile()->push_back(poligoninho);
//
//        pontos.clear();
//        pontos.push_back(Coordenada(0.0,0.0,21.0));
//        pontos.push_back(Coordenada(5.0,0.0,21.0));
//        pontos.push_back(Coordenada(5.0,0.0,21.0));
//        pontos.push_back(Coordenada(5.0,5.0,21.0));
//        Bezier* curvinha = new Bezier("curvinha", pontos, Cor(0.0,255.0,0.0) );
//        ui->canvas->displayFile()->push_back(curvinha);
//
        /*pontos.clear();
        pontos.push_back(Coordenada(0.0,0.0,10.0));
        pontos.push_back(Coordenada(5.0,0.0,10.0));
        pontos.push_back(Coordenada(5.0,5.0,10.0));
        pontos.push_back(Coordenada(0.0,5.0,10.0));
        Poligono* outro = new Poligono("poligono", pontos, Cor(255.255,0.0,0.0), false);
        ui->canvas->displayFile()->push_back(outro);
        */
	ui->help->setVisible(false);

	atualizarLista();
	atualizarCpp();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void MainWindow::on_adicionarButton_clicked()
{
	NovoObjeto dialogo(this);
	if(!dialogo.exec())
		return;

	Objeto* novo = dialogo.obterTipo()->criar();
	if(novo == NULL){
		//TODO Messagem de erro
		return;
	}
	ui->canvas->displayFile()->push_back(novo);

	ui->canvas->update();
	atualizarLista();
	atualizarCpp();
	setFocus(Qt::MouseFocusReason);
}

void MainWindow::atualizarLista(){
	ui->objetos->clear();
	mapaObjetos.clear();
	DisplayFile* display = ui->canvas->displayFile();
	for(std::vector<Objeto*>::iterator i = display->begin(); i != display->end(); i++){
		Objeto* atual = *i;
		QListWidgetItem* atualNaLista = new QListWidgetItem(QString::fromStdString(atual->nome()) + " : " + QString::fromStdString(atual->tipo()));
		ui->objetos->addItem( atualNaLista );
		mapaObjetos[atualNaLista] = atual;
	}
}

void MainWindow::atualizarCpp(){
	ui->canvas->janela()->atualizarCPP(*ui->canvas->displayFile());
}

void MainWindow::on_zoomInButton_clicked()
{
    ui->canvas->janela()->escala(0.9);
    update();
}

void MainWindow::on_zoomOutButton_clicked()
{
	ui->canvas->janela()->escala(1.1);
	update();
}

void MainWindow::on_windowCima_clicked()
{
	ui->canvas->janela()->mover(0.0,0.1,0.0);
	update();
}

void MainWindow::on_windowDireito_clicked()
{
	ui->canvas->janela()->mover(0.1,0.0, 0.0);
	update();
}

void MainWindow::on_windowEsquerda_clicked()
{
	ui->canvas->janela()->mover(-0.1,0.0,0.0);
	update();
}

void MainWindow::on_windowBaixo_clicked()
{
	ui->canvas->janela()->mover(0.0,-0.1,0.0);
	update();
}

void MainWindow::on_objetoAplicarRotacao_clicked()
{
	bool ok = false;
	double angulo = ui->objetoRotacaoDisplay->text().toDouble(&ok);
	
	if(!ok || !mapaObjetos.contains(ui->objetos->currentItem()))
		return;

	Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
	Coordenada centro;
	if(ui->orbitar->isChecked())
		centro = Coordenada(ui->orbitarX->value(), ui->orbitarY->value());
	else
		centro = selecionado->centro();
	Transformacao rotacao = Transformacao::rotacao(angulo, 0.0, 0.0, centro);
	selecionado->aplicarTransformacao(rotacao);
	atualizarCpp();
	update();
}

void MainWindow::on_objetoCima_clicked()
{
	if(!mapaObjetos.contains(ui->objetos->currentItem()))
		return;

	Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
	selecionado->aplicarTransformacao(Transformacao::translacao(0.0,1.0));
	atualizarCpp();
	update();
}

void MainWindow::on_objetoBaixo_clicked()
{
	if(!mapaObjetos.contains(ui->objetos->currentItem()))
		return;

	Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
	selecionado->aplicarTransformacao(Transformacao::translacao(0.0,-1.0));
	atualizarCpp();
	update();
}

void MainWindow::on_objetoDireita_clicked()
{
	if(!mapaObjetos.contains(ui->objetos->currentItem()))
		return;

	Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
	selecionado->aplicarTransformacao(Transformacao::translacao(1.0,0.0));
	atualizarCpp();
	update();
}

void MainWindow::on_objetoEsquerdo_clicked()
{
	if(!mapaObjetos.contains(ui->objetos->currentItem()))
		return;

	Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
	selecionado->aplicarTransformacao(Transformacao::translacao(-1.0,0.0));
	atualizarCpp();
	update();
}

void MainWindow::on_orbitar_toggled(bool checked)
{
    ui->orbitarX->setEnabled(checked);
    ui->orbitarY->setEnabled(checked);
}

void MainWindow::step(double quanto){
	ui->canvas->janela()->mover(0.0,0.0,quanto);
	atualizarCpp();
	update();
}

void MainWindow::keyPressEvent(QKeyEvent * evento){
    switch(evento->key()){
    case Qt::Key_Up:
	on_windowCima_clicked();
	break;
    case Qt::Key_Down:
	on_windowBaixo_clicked();
	break;
    case Qt::Key_Left:
	on_windowEsquerda_clicked();
	break;
    case Qt::Key_Right:
	on_windowDireito_clicked();
	break;
    case Qt::Key_Plus:
	on_zoomInButton_clicked();
	break;
    case Qt::Key_Minus:
	on_zoomOutButton_clicked();
	break;
    case Qt::Key_R:
	on_objetoAplicarRotacao_clicked();
	break;
    case Qt::Key_X:
	rotacionarX();
	break;
    case Qt::Key_Y:
	rotacionarY();
	break;
    case Qt::Key_Z:
	rotacionarZ();
	break;
    case Qt::Key_W:
	on_objetoCima_clicked();
	break;
    case Qt::Key_A:
	on_objetoEsquerdo_clicked();
	break;
    case Qt::Key_S:
	on_objetoBaixo_clicked();
	break;
    case Qt::Key_D:
	on_objetoDireita_clicked();
	break;
    case Qt::Key_N:
	on_adicionarButton_clicked();
	case Qt::Key_O:
	step(-0.1);
	break;
	case Qt::Key_I:
	step(0.1);
	break;
	break;
    case Qt::Key_Escape:
	exit(0);
    }
}

void MainWindow::on_botaoEscala_clicked()
{
    bool ok = false;
    double fator = ui->fatorEscalaDisplay->text().toDouble(&ok);

    if(!ok || !mapaObjetos.contains(ui->objetos->currentItem()))
	    return;

    Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];

	selecionado->aplicarTransformacao(
	    Transformacao::escala(fator, fator, fator, selecionado->centro().x(), selecionado->centro().y(), selecionado->centro().z())
	);

	atualizarCpp();
	update();
}

void MainWindow::on_actionTeclas_de_Atalho_toggled(bool mostrarAjuda)
{
	ui->help->setVisible(mostrarAjuda);
}


void MainWindow::rotacionarX() {
    bool ok = false;
    double angulo = ui->objetoRotacaoDisplay->text().toDouble(&ok);

    if(!ok || !mapaObjetos.contains(ui->objetos->currentItem()))
	    return;

    Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
    Coordenada centro;
    if(ui->orbitar->isChecked())
		centro = Coordenada(ui->orbitarX->value(), ui->orbitarY->value(), 0.0);
    else
	    centro = selecionado->centro();
    Transformacao rotacao = Transformacao::rotacao(angulo, 0.0, 0.0, centro);
    selecionado->aplicarTransformacao(rotacao);
    atualizarCpp();
    update();
}

void MainWindow::rotacionarY() {
    bool ok = false;
    double angulo = ui->objetoRotacaoDisplay->text().toDouble(&ok);

    if(!ok || !mapaObjetos.contains(ui->objetos->currentItem()))
	    return;

    Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
    Coordenada centro;
    if(ui->orbitar->isChecked())
	    centro = Coordenada(ui->orbitarX->value(), ui->orbitarY->value());
    else
	    centro = selecionado->centro();
    Transformacao rotacao = Transformacao::rotacao(0.0, angulo, 0.0, centro);
    selecionado->aplicarTransformacao(rotacao);
    atualizarCpp();
    update();
}

void MainWindow::rotacionarZ() {
    bool ok = false;
    double angulo = ui->objetoRotacaoDisplay->text().toDouble(&ok);

    if(!ok || !mapaObjetos.contains(ui->objetos->currentItem()))
	    return;

    Objeto* selecionado = mapaObjetos[ui->objetos->currentItem()];
    Coordenada centro;
    if(ui->orbitar->isChecked())
	    centro = Coordenada(ui->orbitarX->value(), ui->orbitarY->value());
    else
	    centro = selecionado->centro();
    Transformacao rotacao = Transformacao::rotacao(0.0, 0.0, angulo, centro);
    selecionado->aplicarTransformacao(rotacao);
    atualizarCpp();
    update();
}

void MainWindow::on_windowRotacaoZDisplay_valueChanged(int value)
{
	static int windowRotacaoAntiga = 0.0;
	double angulo = value-windowRotacaoAntiga;
	windowRotacaoAntiga = value;
	ui->canvas->janela()->rodar( 0.0, 0.0, angulo );
	update();
}

void MainWindow::on_windowRotacaoXDisplay_valueChanged(int value)
{
	static int windowRotacaoAntiga = 0.0;
	double angulo = value-windowRotacaoAntiga;
	windowRotacaoAntiga = value;
	ui->canvas->janela()->rodar( angulo, 0.0, 0.0 );
	update();
}

void MainWindow::on_windowRotacaoYDisplay_valueChanged(int value)
{
	static int windowRotacaoAntiga = 0.0;
	double angulo = value-windowRotacaoAntiga;
	windowRotacaoAntiga = value;
	ui->canvas->janela()->rodar( 0.0, angulo, 0.0 );
	update();
}

void MainWindow::on_mostrarCoordenadas_toggled(bool checked)
{
	ui->canvas->showCoordinates(checked);
	update();
}

void MainWindow::on_actionSalvar_triggered()
{
	try {
		std::string file = QFileDialog::getSaveFileName(this, tr("Salvar em..."), "", tr("XML File (*.xml)")).toStdString();
		TiXmlDocument doc;
		TiXmlDeclaration * version = new TiXmlDeclaration( "1.0", "", "" );
		TiXmlElement * formas = new TiXmlElement( "formas" );
		ui->canvas->persist(formas);
		doc.LinkEndChild( version );
		doc.LinkEndChild( formas );
		doc.SaveFile( file.c_str() );
	} catch ( std::string erro ) {
		std::cerr << erro << std::endl;
	}

}

void MainWindow::on_actionCarregar_triggered()
{
	try {
		std::string file = QFileDialog::getOpenFileName(this, tr("Abrir..."), "", tr("XML File (*.xml)")).toStdString();
		TiXmlDocument doc(file.c_str());
		if(!doc.LoadFile())
			throw std::string("Erro desconhecido.");

		TiXmlNode* formas = doc.FirstChild("formas");
		if(formas == NULL)
			throw std::string("Tag raiz 'formas' ausente.");

		ui->canvas->restore(formas);

		atualizarLista();
		update();
	} catch ( std::string erro ) {
		std::cerr << erro << std::endl;
	}

}
