#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMap>
#include <QListWidgetItem>
#include "libcg/objeto.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void keyPressEvent(QKeyEvent *);
protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    void atualizarLista();
	void atualizarCpp();
    QMap<QListWidgetItem*, Objeto*> mapaObjetos;
	int windowRotacaoAntiga;
    void rotacionarX();
    void rotacionarY();
    void rotacionarZ();
	void step(double);
private slots:

	void on_actionCarregar_triggered();
 void on_actionSalvar_triggered();
 void on_mostrarCoordenadas_toggled(bool checked);
 void on_windowRotacaoYDisplay_valueChanged(int value);
	void on_windowRotacaoXDisplay_valueChanged(int value);
	void on_windowRotacaoZDisplay_valueChanged(int value);
	void on_actionTeclas_de_Atalho_toggled(bool );
	void on_botaoEscala_clicked();
	void on_orbitar_toggled(bool checked);
	void on_objetoEsquerdo_clicked();
	void on_objetoDireita_clicked();
	void on_objetoBaixo_clicked();
	void on_objetoCima_clicked();
	void on_objetoAplicarRotacao_clicked();
	void on_windowBaixo_clicked();
	void on_windowEsquerda_clicked();
	void on_windowDireito_clicked();
	void on_windowCima_clicked();
	void on_zoomOutButton_clicked();
	void on_zoomInButton_clicked();
	void on_adicionarButton_clicked();
};

#endif // MAINWINDOW_H
