#include "novoobjeto.h"
#include "ui_novoobjeto.h"
#include <QDialogButtonBox>

#include "libcg/ponto.h"
#include "libcg/reta.h"
#include "libcg/poligono.h"
#include "libcg/bezier.h"
#include "libcg/bspline.h"
#include "libcg/objeto3d.h"

#include <iostream>
NovoObjeto::NovoObjeto(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::NovoObjeto)
{
	ultimo = NULL;
    ui->setupUi(this);

	tiposDeObjetos.push_back( obterFabricaDePonto() );
	tiposDeObjetos.push_back( obterFabricaDeReta() );
	tiposDeObjetos.push_back( obterFabricaDePoligono() );
	tiposDeObjetos.push_back( obterFabricaDeBezier() );
	tiposDeObjetos.push_back( obterFabricaDeBSpline() );
	tiposDeObjetos.push_back( obterFabricaDeObjeto3D() );

	for(std::vector<FabricaDeObjeto*>::iterator i = tiposDeObjetos.begin(); i != tiposDeObjetos.end(); i++){
		ui->tipo->addItem(  QString::fromStdString( (*i)->label() )  );
	}

}

FabricaDeObjeto* NovoObjeto::obterTipo() const{
	for(std::vector<FabricaDeObjeto*>::const_iterator i = tiposDeObjetos.begin(); i != tiposDeObjetos.end(); i++){
		if( (*i)->label() == ui->tipo->currentText().toStdString() )
			return (*i);

	}
	return NULL;
}

NovoObjeto::~NovoObjeto()
{
    delete ui;
}

void NovoObjeto::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void NovoObjeto::on_tipo_currentIndexChanged(QString)
{
	if(ultimo != NULL){
		ui->itensDinamicos->removeWidget(ultimo);
		ultimo->setParent(NULL);
		delete ultimo;
	}
	options = obterTipo()->opcoes();
	ultimo = generateOptionsUi();
	optionValueChanged();
	ui->itensDinamicos->addWidget(ultimo);
}
