#ifndef NOVOOBJETO_OPTIONS_H
#define NOVOOBJETO_OPTIONS_H

#include "novoobjeto.h"
#include <QLineEdit>
#include <QLayout>
#include <QScrollArea>
#include <QDoubleSpinBox>
#include <QSpinBox>
#include <QCheckBox>
#include "QColorWidget/qcolorwidget.h"

class StringOption : public QLineEdit {
	Q_OBJECT
public:
	typedef FabricaDeObjeto::Type Type;
	StringOption(Type* gerenciado);
	virtual ~StringOption(){};
protected slots:
	void valueChanged(QString nova);
signals:
	void valueChanged();
private:
	Type* _gerenciado;
};

class BooleanOption : public QCheckBox {
	Q_OBJECT
public:
	typedef FabricaDeObjeto::Type Type;
	BooleanOption(Type* gerenciado);
	virtual ~BooleanOption(){};
protected slots:
	void valueChanged(bool newValue)	;
private:
	Type* _gerenciado;
};

class ColorOption : public QColorWidget {
	Q_OBJECT
public:
	typedef FabricaDeObjeto::Type Type;
	ColorOption(Type* gerenciado);
	virtual ~ColorOption(){};
protected slots:
	void valueChanged(QColor nova);
signals:
	void valueChanged();
private:
	Type* _gerenciado;
};

class CoordenadaOption : public QWidget {
	Q_OBJECT
public:
	CoordenadaOption(int pos);
	virtual ~CoordenadaOption(){};
protected slots:
	void coordenadaChanged();
signals:
	void coordenadaChanged(double,double,double,int);
private:
	int _pos;
	QDoubleSpinBox *spinX, *spinY, *spinZ;
};

class CoordenadasOption : public QWidget {
	Q_OBJECT
public:
	typedef FabricaDeObjeto::Type Type;
	CoordenadasOption(Type* gerenciado);
	virtual ~CoordenadasOption(){};
protected slots:
	void addCoordenada();
	void removeCoordenada();
	void coordenadaChanged(double,double,double,int);
signals:
	void valueChanged();

private:
	Type* _gerenciado;
	QVBoxLayout* _points;
	QScrollArea* pointsScrollArea;
	QWidget* container;
	QPushButton* add;
	QPushButton* remove;
};

class IntIntOption : public QWidget {
	Q_OBJECT
public:
	IntIntOption(int pos);
	virtual ~IntIntOption() {};
protected slots:
	void intIntChanged();
signals:
	void intIntChanged(int,int,int);
private:
	int _pos;
	QSpinBox *origin, *dest;
};


class IntIntsOption : public QWidget {
	Q_OBJECT
public:
	typedef FabricaDeObjeto::Type Type;
	IntIntsOption(Type* gerenciado);
	virtual ~IntIntsOption(){};
protected slots:
	void addIntInt();
	void removeIntInt();
	void intIntChanged(int,int,int);
private:
	Type* _gerenciado;
	QVBoxLayout* _intInts;
	QScrollArea* intIntsScrollArea;
	QWidget* container;
	QPushButton* add;
	QPushButton* remove;
};

#endif // NOVOOBJETO_OPTIONS_H
