#include "qviewport.h"
#include <QColor>
#include "libcg/reta.h"
#include "libcg/poligono.h"

#include "libcg/curva.h"

QViewport::QViewport ( QWidget * parent ) : QWidget(parent)
{
}

QViewport::~QViewport()
{
}

void QViewport::paintEvent(QPaintEvent * ){
	repintar();
}

void QViewport::iniciarPintura(){
	pintor.begin(this);
	pintor.setBrush(QBrush(QColor(255.0, 255.0, 255.0)));
	pintor.fillRect(0, 0, width()-1, height()-1, Qt::white);
}


void QViewport::finalizarPintura(){
	pintor.setPen(QPen(Qt::black));
	pintor.setBrush(QBrush(Qt::NoBrush));
	pintor.drawRect(20, 20, width()-40, height()-40);
	pintor.end();
}

void QViewport::repintar0(Objeto* atual){
	Cor cor = atual->cor();
	pintor.setPen(QPen(QColor(cor.red(), cor.green(), cor.blue())));
	for(std::vector<Coordenada>::const_iterator i=atual->coordenadasBegin(janela()); i != atual->coordenadasEnd(janela()); i++){
		Coordenada atual = windowToViewport(*i);
		
		pintor.drawLine( atual.x()-2, atual.y()+2,
						 atual.x()+2, atual.y()-2
				);
		pintor.drawLine( atual.x()+2, atual.y()+2,
						 atual.x()-2, atual.y()-2
				);
	}
}


#include <iostream>
void QViewport::repintar1(Objeto* atual){
	if(atual->coordenadasSize(janela()) < 2)
		return;

	Cor cor = atual->cor();
	pintor.setPen(QPen(QColor(cor.red(), cor.green(), cor.blue())));

	std::vector<Coordenada>::const_iterator i=atual->coordenadasBegin(janela());
	Coordenada anterior = windowToViewport(*i);
	for(++i; i != atual->coordenadasEnd(janela()); ++i){
		Coordenada atual = windowToViewport(*i);
		if( ! (i->isNull() || (i-1)->isNull()) ){
			pintor.drawLine(
					anterior.x(), anterior.y(),
					atual.x(), atual.y()
				);
                }
		anterior = atual;
	}

}

void QViewport::pintarInformacoes(Objeto* atual) {
	pintor.setPen(QPen(QColor(0, 0, 0)));
	for(Objeto::iterator i = atual->coordenadasBegin(); i != atual->coordenadasEnd(); ++i){
		Coordenada atual = windowToViewport(*i);
		pintor.drawText( QPoint(atual.x(), atual.y()),
						 QString( "(" ) +
						 QString::number(i->x()) +
						 QString( ", " ) +
						 QString::number(i->y()) +
						 QString( ", " ) +
						 QString::number(i->z()) +
						 QString( ")" )
						 );
	}
}

#include <iostream>
void QViewport::repintar2(Objeto* atual){
	if(atual->coordenadasSize() < 3)
		return;

	using namespace std;

	pintor.setPen(QColor(255,0,0));
	QPointF* pontos = new QPointF[atual->coordenadasSize(janela())];
	pintor.setBrush(QBrush( atual->cor().qcolor() ));

	int pos=0;
	for(std::vector<Coordenada>::const_iterator i=atual->coordenadasBegin(janela()); i != atual->coordenadasEnd(janela()); ++i){
		Coordenada atual = windowToViewport(*i);
		pontos[pos].setX( atual.x() );
		pontos[pos].setY( atual.y() );
		pos++;
	}
	pintor.drawPolygon(pontos, atual->coordenadasSize(janela()));
}
