#include "viewport.h"
#include <iostream>

std::ostream &operator<<(std::ostream &stream, Coordenada o) {
	stream << '(' << o.x() << ',' << o.y() << ')';
	return stream;
}

#include <boost/test/included/unit_test.hpp>

BOOST_AUTO_TEST_SUITE( testes )
BOOST_AUTO_TEST_SUITE( viewport )

class ViewportTamanhoSetavel : public Viewport {
public:
	ViewportTamanhoSetavel(int largura, int altura){
		_altura = altura;
		_largura = largura;
	}
	int largura(){
		return _largura;
	}
	int altura(){
		return _altura;
	}
	void repintar0(Objeto*){
	}
	void repintar1(Objeto*){
	}
	void repintar2(Objeto*){
	}

private:
	int _altura, _largura;
};

BOOST_AUTO_TEST_CASE( converterWindowParaViewport ) {
	ViewportTamanhoSetavel viewport(100, 100);
	Window* janela = viewport.janela();
	BOOST_CHECK_EQUAL(janela->superiorDireito(), Coordenada(10.0, 10.0));
	BOOST_CHECK_EQUAL(janela->inferiorEsquerdo(), Coordenada(-10.0,-10.0));

	BOOST_CHECK_EQUAL(viewport.windowToViewport(Coordenada(-10.0, -10.0)), Coordenada(20.0, 80.0));
	BOOST_CHECK_EQUAL(viewport.windowToViewport(Coordenada(-5.0, -5.0)), Coordenada(35.0, 65.0));
	BOOST_CHECK_EQUAL(viewport.windowToViewport(Coordenada(0.0, 0.0)), Coordenada(50.0, 50.0));
	BOOST_CHECK_EQUAL(viewport.windowToViewport(Coordenada(5.0, 5.0)), Coordenada(65.0, 35.0));
	BOOST_CHECK_EQUAL(viewport.windowToViewport(Coordenada(10.0, 10.0)), Coordenada(80.0, 20.0));
}

BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()

