#ifndef VIEWPORT_H
#define VIEWPORT_H

#include "libcg/displayfile.h"
#include "libcg/window.h"
#include "libcg/objeto.h"
#include "libcg/tinyxml/tinyxml.h"

class Viewport
{
public:
    Viewport();
	virtual ~Viewport();
	DisplayFile* displayFile();
	Window* janela();
public:
	virtual int largura()=0;
	virtual int altura()=0;
	virtual void repintar();
	Coordenada windowToViewport(const Coordenada&);
	void showCoordinates(bool enable);

	void persist(TiXmlNode*) const;
	void restore(TiXmlNode*);
protected:
	virtual void iniciarPintura(){};
	virtual void repintar0(Objeto*)=0;
	virtual void repintar1(Objeto*)=0;
	virtual void repintar2(Objeto*)=0;
	virtual void pintarInformacoes(Objeto*){};
	virtual void finalizarPintura(){};
private :
	DisplayFile* _displayFile;
	Window* _janela;
	bool _debugInformation;
};

#endif // VIEWPORT_H
